unit u_fm_chartable_w;

{
 TEA   
  
       (public domain)
}

{
 It seems that JvCharMap1 doesn't work with Unicode on Win 9x
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, JvExGrids, JvCharMap, StdCtrls;

type
  Tfm_chartable_w = class(TForm)
    JvCharMap1: TJvCharMap;
    cmb_languages: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure cmb_languagesChange(Sender: TObject);
    procedure JvCharMap1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fm_chartable_w: Tfm_chartable_w;

implementation

{$R *.dfm}

uses u_settings, JclStrings, typinfo,
     u_form_main, u_globals;

procedure Tfm_chartable_w.FormCreate(Sender: TObject);
var
   I: TJvCharMapUnicodeFilter;
   t: string;
begin
     JvCharMap1.Font.Name := settings.font_name;

     cmb_languages.Items.BeginUpdate;

     try
        cmb_languages.Items.Clear;
        for I := Low(TJvCharMapUnicodeFilter) to High(TJvCharMapUnicodeFilter) do
            begin
                 t := StrRestOf (GetEnumName (TypeInfo (TJvCharMapUnicodeFilter), Ord (I)), 3);
                 cmb_languages.Items.Add (t);
            end;
     finally
            cmb_languages.Items.EndUpdate;
     end;

    cmb_languages.ItemIndex := last_uni_index;
    JvCharMap1.CharRange.Filter := TJvCharMapUnicodeFilter (cmb_languages.ItemIndex);
end;


procedure Tfm_chartable_w.cmb_languagesChange(Sender: TObject);
begin
     JvCharMap1.CharRange.Filter := TJvCharMapUnicodeFilter (cmb_languages.ItemIndex);
     last_uni_index := cmb_languages.ItemIndex;
end;


procedure Tfm_chartable_w.JvCharMap1Click(Sender: TObject);
begin
     if get_current_editor = nil then
        exit;

     if current_editor.is_utf8 then
        current_editor.ins_at_cursor_w (JvCharMap1.Character);
end;

end.
