unit u_fm_unitaz;

{
 TEA   
  
       (public domain)
}


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, JvExStdCtrls, JvRichEdit;

type
  Tfm_UnitazOutput = class(TForm)
    btCopyToClipboard: TButton;
    btClose: TButton;
    ed_out: TJvRichEdit;
    procedure btCloseClick(Sender: TObject);
    procedure btCopyToClipboardClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

UNITHREAD = class (TThread)

  protected
    procedure Execute; override;
    procedure HNDLE;
    procedure Stop;

  public
    f_mode:byte;
end;

var
   fm_UnitazOutput: Tfm_UnitazOutput;
   th: UNITHREAD;
   pv: TThreadPriority;
   sNoOneFileOpened, sEvalWait:string;

procedure U_R_u_n (a_mode: byte);

implementation

uses clipbrd, u_unitaz, u_form_main;

{$R *.DFM}

procedure UNITHREAD.Stop;
begin
     Terminate;
end;


procedure UNITHREAD.Execute;
begin
     HNDLE;
end;

procedure UNITHREAD.HNDLE;
var
   st: CNewStat;
begin
      if get_current_editor = nil then
        exit;

      st := CNewStat.Create (current_editor.get_selection);
      st.mode := f_mode;
      st.Xecute (fm_UnitazOutput.ed_out.lines, true);
      st.free;
end;


procedure U_R_u_n (a_mode: byte);
begin
   //  if fm_UnitazOutput = nil then
     fm_UnitazOutput := Tfm_UnitazOutput.Create (fm_main);

     fm_UnitazOutput.show;

     th := UNITHREAD.Create (TRUE);
     th.f_mode := a_mode;
     th.FreeOnTerminate := true;
     th.Priority := tpNormal;
     th.Resume;
end;


procedure Tfm_UnitazOutput.btCloseClick(Sender: TObject);
begin
     close;
end;


procedure Tfm_UnitazOutput.btCopyToClipboardClick(Sender: TObject);
begin
     clipboard.astext := ed_out.lines.text;
end;

procedure Tfm_UnitazOutput.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
     if th <> nil then
        begin
             th.Stop;
             th.Terminate;
        end;

     action := caFree;
end;

end.
